<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html>
<html>
<head>
 <title>Bitcoin wallet in your browser</title>
 <meta http-equiv="content-type" content="application/xml;charset=utf-8"/>
 <!--
 Copyright (c) 2015, haael.co.uk
 Attribution-ShareAlike 4.0 International (CC BY-SA 4.0)
 
 This is a human-readable summary of (and not a substitute for) the license.
 
 You are free to:
     Share — copy and redistribute the material in any medium or format
     Adapt — remix, transform, and build upon the material
     for any purpose, even commercially.
     The licensor cannot revoke these freedoms as long as you follow the license terms.
 
 Under the following terms:
     Attribution — You must give appropriate credit, provide a link to the license, and
     indicate if changes were made. You may do so in any reasonable manner, but not in
     any way that suggests the licensor endorses you or your use.
 
     ShareAlike — If you remix, transform, or build upon the material, you must
     distribute your contributions under the same license as the original.
 
     No additional restrictions — You may not apply legal terms or technological
     measures that legally restrict others from doing anything the license permits.
 
 Notices:
     You do not have to comply with the license for elements of the material in the
     public domain or where your use is permitted by an applicable exception or limitation.
     No warranties are given. The license may not give you all of the permissions necessary
     for your intended use. For example, other rights such as publicity, privacy, or moral
     rights may limit how you use the material.
 
 https://creativecommons.org/licenses/by-sa/4.0/legalcode
 -->
 <link rel="author" href="http://haael.co.uk"/>
 <link rel="license" href="https://creativecommons.org/licenses/by-sa/4.0/legalcode"/>
 <link rel="stylesheet" type="text/css" href="http://fonts.googleapis.com/css?family=Monda"/>
 <link rel="stylesheet" type="text/css" href="style.css"/>
 <script type="text/javascript" src="brython/brython.js"></script>
 <style type="text/css">
  nav { display: none; }
  div#console { display: none; }
  div#bottombar { display: none; }

  #vanilla { display: none; }
  #vanity { display: none; }
  #deterministic { display: none; }
  #vanity_deter { display: none; }
  #multisig { display: none; }

  #spend { display: none; }
  #spend_deter { display: none; }
  #spend_multisig { display: none; }

  #sign { display: none; }
  #sign_multisig { display: none; }

  #colored { display: none; }
  #colored_deter { display: none; }
  #colored_multisig { display: none; }

  #findaddress { display: none; }
 </style>
 <script type="text/python3">
  # /* <![CDATA[
  '''
   Copyright (c) 2015, haael.co.uk
   GNU General Public License v3.0 or later

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see < http://www.gnu.org/licenses/ >.

   http://www.gnu.org/licenses/gpl-3.0.en.html
  '''
  
  from browser import document, window, alert, html
  
  try:
      from bitcoin import hmac
      
      sections = ['findaddress', 'vanilla', 'vanity', 'deterministic', 'vanity_deter', 'multisig']
      
      def unhide_sections(name):
          for nm in sections:
              document[nm].style.display = 'none'
          if name in sections:
              document[name].style.display = 'block'
          else:
              document['findaddress'].style.display = 'block'
  
      def goto_section(name):
          unhide_sections(name)
          document.location.hash = '#' + name
      
      for s in sections:
          closure = (lambda z: (lambda x: goto_section(z)))(s)
          document['nav_' + s].bind('click', closure)
      
      document.get(selector='nav')[0].style.display = 'block'
      
      unhide_sections(document.location.hash[1:])
      
      document['bottombar'].style.display = 'block'
      
      window.bind('hashchange', lambda x: unhide_sections(document.location.hash[1:]))
  except Exception as error:
      #import traceback
      document['bottombar'].style.display = 'block'
      document['console'].style.display = 'block'
      text = html.PRE()
      text <= type(error).__name__ + ": " + str(error)
      document['console'] <= text
  
 # ]]> */
 </script>
</head>

<body onload="brython({debug:1, cache:'none'})">

<header>
  This is a bitcoin wallet that runs (almost) exlusively in your browser. It does not require any
  registration.<br/> <strong>YOU USE THIS SERVICE AT YOUR OWN RISK, WITHOUT ANY WARRANTY!</strong><br/>
</header>

<noscript>
 <h1>You must enable JavaScript to use this service.</h1>
 <p>
  This page uses Brython (Python implementation in JavaScript) and modified Python PyBitcoinTools module.
  If you are unsure whether this service can be trusted, you can download and review the libraries
  used. Brython and all modules are hosted under the same domain so they can not be modified by third
  party.
 </p>
 <p>
  You are welcome to send any security related insights to the address to help us improve this site.
 </p>
</noscript>

<div id="console">
 <h1>Error</h1>
</div>

<nav>
 Choose your wallet type:<br/>
 <div>
  <button id="nav_vanilla">Vanilla</button>
  <button id="nav_vanity">Vanity</button>
  <button id="nav_deterministic">Deterministic</button>
  <button id="nav_vanity_deter">Vanity-Deter</button>
  <button id="nav_multisig">Multisig</button>
 </div>
 Or look for address:<br/>
 <div>
  <button id="nav_findaddress">Find address</button>
 </div>
</nav>

<section id="findaddress">
 <h1>Find address</h1>
 <p>
  Type the address or part of the address or full public key if you have one. Then click one of
  the search buttons.
 </p>
 <fieldset id="findaddress_generate">
  <input type="checkbox" id="findaddress_enablepubkey"/> <span class="label">Public key <span class="optional">(optional)</span>:</span> <input type="text" id="findaddress_pubkey" disabled="disabled"/><br/>
  <span class="label">Address:</span> <input type="text" id="findaddress_address"/><br/>
   <button type="button" id="findaddress_database">Search our database</button>
   <button type="button" id="findaddress_blockchain">Search unspent outputs</button>
   <button type="button" id="findaddress_blockchain">Search blockchain</button><br/>
  <span class="label">Present in our database:</span> <input type="text" readonly="true" class="short" id="findaddress_db_present" for="findaddress_address findaddress_pubkey"/>
   type: <input type="text" readonly="true" class="short" id="findaddress_type" for="findaddress_address findaddress_pubkey"/><br/>
  <span class="label">Present in blockchain:</span> <input type="text" readonly="true" class="short" id="findaddress_bc_present" for="findaddress_address findaddress_pubkey"/><br/>
  <span class="label">Balance:</span> <input type="text" readonly="true" id="findaddress_value" for="findaddress_address findaddress_pubkey"/><br/>
 </fieldset>
</section>

<section id="vanilla">
 <h1>Plain vanilla wallet</h1>
 <p>
  Use this form to manage a normal Bitcoin wallet. The address will start with "1". The keys are created
  from the provided seed phrase only. You will be able to spend your bitcoins using the same phrase. You
  will have an option to save the generated public key and address in our database. The private key and
  the seed phrase will <strong>not</strong> be stored.<br/>
  You can also generate public key and address from private key.
 </p>
 <p class="security">
  <strong>Don't forget the seed phrase.</strong> Write it down and
  store in a safe place. If you forget the phrase, spending bitcoins will be impossible. <strong>Don't
  reveal the seed phrase to anyone.</strong> If your phrase leaks, your bitcoins might be stolen. Don't
  reuse the phrase on other websites. Use a long phrase, not appearing anywhere on Internet or in literature.
  We take no responsibility of your funds safety.
  <br/>
  <input type="checkbox" id="vanilla_accepted"/> I understand.
 </p>
 <fieldset disabled="true" id="vanilla_generate">
  <button type="button" id="vanilla_roll">Pick random passphrase</button><br/>
  <span class="label">Secret phrase:</span> <input type="text" autocomplete="off" id="vanilla_seed"/><br/>
  <span class="label">Private key <span class="optional">(optional)</span>:</span> <input type="text" autocomplete="off" id="vanilla_privkey"/><br/>
  <button type="button" id="vanilla_generate">Generate in browser</button>
   <button type="button" id="vanilla_restore">Restore from database</button>
   <button type="button" id="vanilla_save" disabled="true">Save public keys</button><br/>
  <span class="label">Public key:</span> <input type="text" readonly="true" id="vanilla_pubkey"/><br/>
  <span class="label">Address:</span> <input type="text" readonly="true" id="vanilla_address"/>
 </fieldset>
</section>

<section id="vanity">
 <h1>"Vanity" wallet with prefix</h1>
 <p>
 </p>
 <fieldset disabled="true" id="vanity_generate">
  <span class="label">Prefix:</span> 1<input type="text" class="short" id="vanity_prefix"/> serial <span class="optional">(optional)</span>: <input type="text" class="short" id="vanity_serial"/><br/>
  <button type="button" id="vanity_roll">Pick random passphrase</button><br/>
  <span class="label">Secret phrase:</span> <input type="text" autocomplete="off" id="vanity_seed"/><br/>
  <span class="label">Private key <span class="optional">(optional)</span>:</span> <input type="text" autocomplete="off" id="vanity_privkey"/><br/>
   <button type="button" id="vanity_generate">Generate in browser</button>
   <button  type="button" id="vanity_restore">Restore from database</button>
   <button type="button" id="vanilla_save" disabled="true">Save public keys</button><br/>
  <span class="label">Public key:</span> <input type="text" id="vanity_pubkey"/><br/>
  <span class="label">Address:</span> <input type="text" id="vanity_address"/>
 </fieldset>
</section>

<section id="deterministic">
 <h1>Deterministic multi-address wallet</h1>
 <p>
 </p>
</section>

<section id="vanity_deter">
 <h1>"Vanity" deterministic multi-address wallet</h1>
 <p>
 </p>
</section>

<section id="multisig">
 <h1>Multisignature wallet</h1>
 <p>
 </p>
</section>




<section id="spend" class="secondary">
 <h2>Spend from single address</h2>
</section>

<section id="spend_deter" class="secondary">
 <h2>Spend from deterministic wallet</h2>
 <p>
  Here you can spend your bits.
 </p>
</section>

<section id="spend_multisig" class="secondary">
 <h2>Spend from multisignature wallet</h1>
</section>

<section id="sign" class="secondary">
 <h2>Sign document</h2>
</section>

<section id="sign_multisig" class="secondary">
 <h2>Document multi-signing</h2>
</section>

<section id="colored" class="secondary">
 <h2>Colored coins transfer</h2>
</section>

<section id="colored_deter" class="secondary">
 <h2>Colored coins transfer from deterministic walled</h2>
</section>

<section id="colored_multisig" class="secondary">
 <h2>Colored coins multisignature transfer</h2>
</section>

<div id="bottombar">
 &nbsp;
</div>

<footer>
 <p>
  You use this site AT YOUR OWN RISK.<br/>
  We do not give ANY WARRANTY of any kind.<br/>
  We DO NOT STORE any private keys, seeds nor any other information that may be used to spend bitcoins.<br/>
  We CAN STORE public keys and other public cryptographic information on user request.<br/>
  We DO NOT GUARANTEE RETAINING any information stored in our databases.<br/> 
  We DO NOT GUARANTEE that the returned information is relevant or CORRECT.<br/>
  We CAN STORE statistical information of internet connections used to access this service.<br/>
  We CAN STORE any information when we are OBLIGED BY LAW to do so.<br/>
  You are at the risk of LOSING YOUR FUNDS when using this service.<br/>
  You are at the risk of BEING UNDER SURVEILLANCE when using this service.<br/>
  This service does not require any registration, identification or proof of identity.<br/>
  This service does not use cookies.<br/>
  This service does not give you ANY WARRANTY OF ANONYMITY.<br/>
  This service does not provide any technical support.<br/>
  This service does not provide any help related to using bitcoin technology.<br/>
 </p>
 <p>
  THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM “AS IS” WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
 </p>
 <p>
  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 </p>
 <ul>
  <li>[<a href="https://creativecommons.org/licenses/by-sa/4.0/legalcode">CC BY-SA 4.0</a>] All author visual content on this site is covered by CC Attribution-ShareAlike license v4.0. <strong>Copyright (c) 2015, haael.co.uk</strong></li>
  <li>[<a href="http://www.gnu.org/licenses/gpl-3.0.en.html">GNU GPL v3.0</a> or later] Author script parts of this site are covered by GNU GPL license v3.0 or any later version. <strong>Copyright (c) 2015, haael.co.uk</strong></li>
  <li>[<a href="https://github.com/brython-dev/brython/blob/master/LICENCE.txt">All Rights Reserved</a>] This site uses <a href="http://brython.info">Brython</a> (Python3 in Javascript) interpreter. <strong>Copyright (c) 2012, Pierre Quentel (pierre.quentel@gmail.com)</strong></li>
  <li>[Public Domain / <a href="https://github.com/vbuterin/pybitcointools/blob/master/LICENSE">MIT</a>] This site uses modified <a href="https://github.com/vbuterin/pybitcointools">pybitcointools</a> Python module.<strong>Copyright (c) 2012, Vitalik Buterin [modifications (c) 2015, haael.co.uk]</strong>
  <li>[Public Domain / <a href="https://creativecommons.org/publicdomain/zero/1.0/legalcode">CC0 1.0</a>] This site uses free stock photos from <a href="http://pixabay.com">pixabay.com</a>. <strong>Public Domain</strong></li>
  <li>[<a href="http://scripts.sil.org/OFL_web">SIL OF 1.1</a>] This site uses Google Fonts covered by SIL Open Font license v1.1. <strong>Copyright (c) 2012, Vernon Adams (vern@newtypography.co.uk), with Reserved Font Names 'Monda'</strong></li>
 </ul>
 <img src="bitcoin.svg" width="147" height="31" alt="Bitcoin"/>
 <img src="cc-by-sa.png" alt="CC BY-SA 4.0"/>
 <img src="gplv3.png" alt="GNU GPL v3.0"/>
</footer>

</body>
</html>

